import React from "react";
import { BrowserRouter as Router, Route, Link } from "react-router-dom";
import { Bureau } from "./Bureau.js";
import { SalleA111 } from "./SalleA111.js";
import { Yeux } from "./Yeux.js";
// import {
//   createSensor,
//   createData,
//   getSensor,
//   getData,
//   lastDate,
//   valMoy,
//   TYPE
// } from "./Obj/ObjectModel/src";
//
// let tabData = [];
// Store/retrieve the name in/from a cookie.

// Listen to messages coming from the server. When it happens, create a new <li> and append it to the DOM.
// Retrieve the input element. Add listeners in order to send the content of the input when the "return" key is pressed.
// clientMqtt.on("connect", function() {
//   clientMqtt.subscribe("value/#");
// });
// const arrayCapteur = [];
// let line;
//
// clientMqtt.on("message", function(topic, message) {
//   var element = document.getElementsByTagName("li"),
//     index;
//
//   // for (index = element.length - 1; index >= 0; index--) {
//   //   //console.log(element[index].parentNode);
//   //   //element[index].parentNode.removeChild(element[index]);
//   // }
//   let obj = JSON.parse(message);
//   let value = obj["value"];
//   let type = obj["type"];
//
//   let exist = false;
//   let valueId = topic.substring(topic.indexOf("/") + 1);
//   arrayCapteur.forEach(function(capt) {
//     //console.log("captid "+ capt.name + " obj: " + valueId )
//
//     if (capt.name === valueId) {
//       tabData[capt.id]["value"] += parseFloat(obj["value"]);
//       tabData[capt.id]["nbVal"]++;
//       capt.data = obj["value"];
//       exist = true;
//     }
//     console.log(obj);
//   });
//
//   if (!exist) {
//     let capteur = new createSensor();
//     capteur.id = valueId;
//     capteur.name = valueId;
//     capteur.type = type;
//     capteur.data += value;
//
//     tabData[capteur.id] = { value: parseFloat(obj["value"]), nbVal: 1 };
//     arrayCapteur.push(capteur);
//     //console.log(arrayCapteur.length);
//   }
//   arrayCapteur.forEach(function(capt) {
//     let moyenne = tabData[capt.id]["value"] / tabData[capt.id]["nbVal"];
//     if (!isNaN(moyenne)) {
//       const Ventilateur = {
//         type: capt.type,
//         value: capt.data,
//         moyenne: moyenne.toFixed(4)
//       };
//     } else {
//       const Ventilateur = {
//         type: capt.type,
//         value: capt.data
//       };
//     }
//   });
//   //clientMqtt.end()
// });
var adress = "ws://192.168.99.100:1234";
export class App extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      messages: {
        MesYeux: { value: [] },
        Bureau: { value: [] },
        SalleA111: { value: [] }
      }
    };
  }

  componentDidMount() {
    let data = this;
    var mqtt = require("mqtt");
    var clientMqtt = mqtt.connect(adress);
    const cookies = document.cookie.split(";");
    const ws = new WebSocket("ws://" + window.location.host + "/socket");

    ws.onopen = event => {
      console.log("We are connected.");
    };
    clientMqtt.on("connect", function() {
      clientMqtt.subscribe("value/#");
    });
    clientMqtt.on("message", function(topic, message) {
      let obj = JSON.parse(message);
      //console.log("test");

      //  console.log(data.state.messages["SalleA111"].value);
      switch (topic.substring(topic.indexOf("/") + 1)) {
        case "MesYeux":
          if (data.state.messages["MesYeux"].value.length > 10) {
            data.state.messages["MesYeux"].value.shift();
            data.state.messages["MesYeux"].value.push(obj.value);
            data.setState({
              SalleA111: {
                value: data.state.messages["MesYeux"].value
              }
            });
          } else
            MesYeux: {
              value: data.state.messages["MesYeux"].value.push(obj.value);
            }
          break;
        case "temperatureChambre":
          if (data.state.messages["Bureau"].value.length > 10) {
            data.state.messages["Bureau"].value.shift();
            data.state.messages["Bureau"].value.push(obj.value);
            data.setState({
              SalleA111: {
                value: data.state.messages["Bureau"].value
              }
            });
          } else
            SalleA111: {
              value: data.state.messages["Bureau"].value.push(obj.value);
            }
          break;
        case "temperatureSalleA111":
          if (data.state.messages["SalleA111"].value.length > 10) {
            data.state.messages["SalleA111"].value.shift();
            data.state.messages["SalleA111"].value.push(obj.value);
            data.setState({
              SalleA111: {
                value: data.state.messages["SalleA111"].value
              }
            });
          } else
            data.setState({
              SalleA111: {
                value: data.state.messages["SalleA111"].value.push(obj.value)
              }
            });
          break;
      }
    });
  }

  render() {
    return (
      <Router>
        <div className="sensor_select">
          <div className="brocker"> URL du brocker </div>
          <div className="urlBrocker"> {adress + ""} </div>
          <div className="sensor_list_wrapper">
            <div className="sensor_list">
              <div>
                <Link to="/Bureau">Bureau</Link>
              </div>
              <div>
                <Link to="/mesYeux">Mes yeux</Link>
              </div>
              <div>
                <Link to="/SalleA111">Salle A111</Link>
              </div>
            </div>

            <div className="sensor_title">
              <Route
                exact
                path="/Bureau"
                render={props => (
                  <Bureau data={this.state.messages["Bureau"].value} />
                )}
              />
              <Route
                path="/mesYeux"
                render={props => (
                  <Yeux data={this.state.messages["MesYeux"].value} />
                )}
              />
              <Route
                path="/SalleA111"
                render={props => (
                  <SalleA111 data={this.state.messages["SalleA111"].value} />
                )}
              />
            </div>
            <div className="fill" />
            <div className="fill" />
          </div>
        </div>
      </Router>
    );
  }
}
export default App;
