import { data } from "../resources/sensors_data";
export const version = () => "1.0.0";

/* TODO : Créer le modèle objet ici */

export const TYPE = {
  TEMPERATURE: "TEMPERATURE",
  FAN_SPEED: "FAN_SPEED",
  DOOR: "DOOR",
  HUMIDITY: "HUMIDITY",
  LIGHT: "LIGHT",
  SWITCH: "SWITCH",
  ON_OFF: "ON_OFF",
  OPEN_CLOSE: "OPEN_CLOSE",
  PERCENT: "PERCENT"
};

export const createSensor = () => {
  return Object.create(Object.prototype, {
    id: { value: "", writable: true },
    name: { value: "", writable: true },
    type: { value: "", writable: true },
    data: { value: "", writable: true }
  });
};

export const createData = () => {
  return Object.create(Object.prototype, {
    values: { value: Array, writable: true },
    labels: { value: Array, writable: true },
    value: { value: "", writable: true },
    toString: {}
  });
};

export const getData = () => {
  var arrayData = [];
  var s;
  var createDat;
  for (s = 0; s < data.length; s++) {
    createDat = new createData();
    createDat.values = data[s].data.values;
    createDat.labels = data[s].data.labels;
    createDat.value = data[s].data.value;
    arrayData.push(createDat);
  }
  //console.log(arrayData +"");
  return arrayData;
};

export const getSensor = () => {
  var arrayData = [];
  var s;
  var createSens;
  for (s = 0; s < data.length; s++) {
    createSens = new createSensor();
    createSens.id = data[s].id;
    createSens.name = data[s].name;
    createSens.type = data[s].type;
    arrayData.push(createSens);
  }
  //console.log(arrayData +"");
  return arrayData;
};

export const lastDate = i => {
  var s = "";
  // console.log(data[i].data.labels[(data[i].data.labels).length-1]);
  if (data[i].data.labels !== undefined)
    s += data[i].data.labels[data[i].data.labels.length - 1];
  else s += "Pas de date";
  return s;
};

export const valMoy = i => {
  var moy = 0;
  if (typeof data[i].data.values !== "undefined") {
    for (var j = 0; j < data[i].data.values.length; j++) {
      moy += data[i].data.values[j];
    }
    moy = moy / data[i].data.values.length;
  }
  return moy;
};
